# -*- coding: utf-8 -*-

"""

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import urllib, sys, re, os, string, random, unicodedata
import xbmc, xbmcgui, xbmcplugin, xbmcaddon, xbmcvfs

try:
    # Python 3
    from urllib.request import urlopen, Request, HTTPError
except ImportError:
    # Python 2
    from urllib2 import urlopen, Request, HTTPError

try:
    # Python 3
    from html.parser import HTMLParser
except ImportError:
    # Python 2
    from HTMLParser import HTMLParser

#==============================================================================================================================

IS_PY3 = sys.version_info[0] > 2

if IS_PY3:
	from urllib.request import Request
	from urllib.request import urlopen
	from urllib.parse import unquote_plus, quote_plus
else:
	from urllib2 import Request, urlopen
	from urllib import unquote_plus, quote_plus

dlg = xbmcgui.Dialog()
addon = xbmcaddon.Addon()
addon_name = addon.getAddonInfo('name')
addon_id = addon.getAddonInfo('id')
plugin_path = xbmcaddon.Addon(id=addon_id).getAddonInfo('path')
addon_handle = int(sys.argv[1])

try:
    fanart = xbmcvfs.translatePath(os.path.join(plugin_path, 'fanart.jpg'))
    icon = xbmcvfs.translatePath(os.path.join(plugin_path, 'icon.png'))
except:
    fanart = xbmc.translatePath(os.path.join(plugin_path, 'fanart.jpg'))
    icon = xbmc.translatePath(os.path.join(plugin_path, 'icon.png'))

HOME     = 'special://home'
PROFILE  = 'special://profile'
DATABASE = os.path.join(PROFILE,'Database')

#==============================================================================================================================

def get_params():
    param = []
    paramstring = sys.argv[2]
    if len(paramstring) >= 2:
        params = sys.argv[2]
        cleanedparams = params.replace('?', '')
        if (params[len(params) - 1] == '/'):
            params = params[0:len(params) - 2]
        pairsofparams = cleanedparams.split('&')
        param = {}
        for i in range(len(pairsofparams)):
            splitparams = {}
            splitparams = pairsofparams[i].split('=')
            if (len(splitparams)) == 2:
                param[splitparams[0]] = splitparams[1]

    return param


def get_setting(setting):
    return addon.getSetting(setting)

def set_setting(setting, string):
    return addon.setSetting(setting, string)

def get_string(string_id):
    return addon.getLocalizedString(string_id)

def build_url(query):
    return base_url + '?' + urllib_parse.urlencode(query)

#==============================================================================================================================

def add_link(name, url, mode, iconimage, fanart, description):

	try: #Python 3
		u = sys.argv[0] + "?url=" + urllib.parse.quote_plus(url) + "&mode=" + str(mode) + "&name=" + urllib.parse.quote_plus(name) + "&iconimage=" + urllib.parse.quote_plus(iconimage) + "&description=" + str(description)
		ok=True
		liz = xbmcgui.ListItem(name)
		liz.setArt({'thumb': iconimage, 'icon': "DefaultVideo.png", 'fanart': fanart})
		liz.setInfo('pictures', infoLabels={ "exif:comment": str(description), "title": "blaat" })
		liz.setInfo( type = "Video", infoLabels = { "Title": name, 'plot': description  } )
		liz.setProperty('fanart_image', fanart)
		liz.setProperty('IsPlayable', 'true')
		ok = xbmcplugin.addDirectoryItem(handle = int(sys.argv[1]), url = u, listitem = liz, isFolder = False)  
	except: #Python 2
		u = sys.argv[0] + "?url=" + urllib.quote_plus(url) + "&mode=" + str(mode) + "&name=" + urllib.quote_plus(name) + "&iconimage=" + urllib.quote_plus(iconimage) + "&description=" + str(description)
		liz = xbmcgui.ListItem(name, iconImage = icon, thumbnailImage = iconimage)
		liz.setInfo('pictures', infoLabels={ "exif:PictureComment": str(description), "title": "blaat" })
		liz.setInfo( type = "Video", infoLabels = { "Title": name, 'plot': description  } )
		liz.setProperty('fanart_image', fanart)
		liz.setProperty('IsPlayable', 'true') 
		ok = xbmcplugin.addDirectoryItem(handle = int(sys.argv[1]), url = u, listitem = liz, isFolder = False)  

#==============================================================================================================================

def addLINK(name,url,mode,iconimage,fanart):
    u=sys.argv[0]+"?url="+quote_plus(url)+"&mode="+str(mode)+"&name="+quote_plus(name)
    ok=True
    liz=xbmcgui.ListItem(name)
    liz.setArt({'thumb': iconimage, 'icon': "DefaultVideo.png", 'iconImage': "DefaultFolder.png", 'thumbnailImage': iconimage, 'fanart': fanart})
    liz.setInfo(type="Video", infoLabels={"Title": name})
    liz.setProperty('fanart_image', fanart)
    if mode==30:
        liz.setProperty("IsPlayable","true")
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
    else:
        ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
    return ok

#==============================================================================================================================

def addDirMain(name,url,mode,iconimage,fanart):
  try: #Python 3
    u=sys.argv[0]+"?url="+urllib.parse.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.parse.quote_plus(name)
    ok=True
    liz = xbmcgui.ListItem(name)
    liz.setArt({'thumb': iconimage, 'icon': "DefaultVideo.png", 'fanart': fanart})
    liz.setInfo( type = "Video", infoLabels = { "Title": name } )
    liz.setProperty('IsPlayable', 'false')
    ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
    return ok
  except: #Python2
    u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
    ok=True
    liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
    liz.setProperty('fanart_image', fanart)
    ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
    return ok

#==============================================================================================================================

def add_link_info(name, iconimage, fanart):
  try: #Python3
    u = sys.argv[0] + "&name=" + urllib.parse.quote_plus(name) + "&iconimage=" + urllib.parse.quote_plus(iconimage)	
    liz = xbmcgui.ListItem(name)
    liz.setArt({'thumb': iconimage,
                      'icon': "DefaultVideo.png",
                      'fanart': fanart})
    ok = xbmcplugin.addDirectoryItem(handle = int(sys.argv[1]), url = u, listitem = liz) 
    return ok
  except: #Python2
    u = sys.argv[0] + "&name=" + urllib.quote_plus(name) + "&iconimage=" + urllib.quote_plus(iconimage)	
    liz = xbmcgui.ListItem(name, iconImage = "DefaultVideo.png", thumbnailImage = iconimage)
    liz.setInfo( type = "Video", infoLabels = { "Title": name } )
    liz.setProperty('fanart_image', fanart)
    liz.setProperty('IsPlayable', 'false') 
    ok = xbmcplugin.addDirectoryItem(handle = int(sys.argv[1]), url = u, listitem = liz) 

#==============================================================================================================================

def addLink(name, url, mode, iconimage, fanart):
  try: #Python 3
    u=sys.argv[0]+"?url="+urllib.parse.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.parse.quote_plus(name)+"&iconimage="+urllib.parse.quote_plus(iconimage)
    ok=True
    liz = xbmcgui.ListItem(name)
    liz.setArt({'thumb': iconimage, 'icon': "DefaultVideo.png", 'fanart': fanart})
    liz.setInfo( type = "Video", infoLabels = { "Title": name } )
    liz.setProperty('IsPlayable', 'true')
    ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
    return ok
  except: #Python2
    u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)
    liz=xbmcgui.ListItem(name)
    liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
    liz.setInfo( type="Video", infoLabels={"Title": name})		
    liz.setProperty('fanart_image', fanart)
    liz.setProperty('IsPlayable', 'true')
    ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)		
    return ok

#==============================================================================================================================

def Add_Dir(name, url='', mode='', folder=False, icon='', fanart='', description='', info_labels={}, set_art={}, set_property={}, content_type='', context_items=None, context_override=False, playable=False):

    filepath=HOME

    info_labels["Title"] = name
    info_labels["FileName"] = name

    try:
        plot = info_labels["plot"]
        if plot == '':
            info_labels["plot"] = description
    except:
        info_labels["plot"] = description
    try:
        set_art["icon"]
    except:
        set_art["icon"] = icon
    try:
        set_property["Fanart_Image"] = fanart
    except:
        set_property["Fanart_Image"]

    iconImage=str(icon) 
    thumbnailImage=str(icon)

    liz = xbmcgui.ListItem(label=str(name))
    liz.setArt({'thumb': str(icon), 'icon': iconImage, 'fanart': fanart})
    liz.setInfo(type=content_type, infoLabels=info_labels)

    for item in set_property.items():
        liz.setProperty(item[0], item[1])

    if context_items:
        liz.addContextMenuItems(context_items, context_override)

    u   = sys.argv[0]
    u += "?mode="           +str(mode)
		
    try: #Python 3
        Ncodepath  = urllib.parse.quote(HOME)
        Ncodepath2 = Ncodepath.replace('%3A','%3a').replace('%5C','%5c')
        theString = filepath.replace(HOME, 'special://home/').replace(Ncodepath, 'special://home/').replace(Ncodepath2, 'special://home/')
	
        u += "&url="            +urllib.parse.quote_plus(theString)
        u += "&name="           +urllib.parse.quote_plus(name)
        u += "&iconimage="      +urllib.parse.quote_plus(icon)
        u += "&fanart="         +urllib.parse.quote_plus(fanart)
        u += "&description="    +urllib.parse.quote_plus(description)
 
    except: #Python 2	
        Ncodepath  = urllib.quote(HOME)
        Ncodepath2 = Ncodepath.replace('%3A','%3a').replace('%5C','%5c')
        theString = filepath.replace(HOME, 'special://home/').replace(Ncodepath, 'special://home/').replace(Ncodepath2, 'special://home/')
	
        u += "&url="            +urllib.quote_plus(theString)
        u += "&name="           +urllib.quote_plus(name)
        u += "&iconimage="      +urllib.quote_plus(icon)
        u += "&fanart="         +urllib.quote_plus(fanart)
        u += "&description="    +urllib.quote_plus(description)
   
    if url.startswith('plugin://'):
        xbmcplugin.addDirectoryItem(handle=addon_handle,url=url,listitem=liz,isFolder=True) 

    elif folder:
        xbmcplugin.addDirectoryItem(handle=addon_handle,url=u,listitem=liz,isFolder=True)

    elif playable:
        liz.setProperty('IsPlayable', 'true')
        xbmcplugin.addDirectoryItem(handle=addon_handle,url=url,listitem=liz,isFolder=False) 

    else:
        xbmcplugin.addDirectoryItem(handle=addon_handle,url=u,listitem=liz,isFolder=False) 

#==============================================================================================================================

def addLinkYT(name, url, mode, iconimage, fanart, thePoster):
  try: #Python 3
    #u=sys.argv[0]+"?url="+urllib.parse.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.parse.quote_plus(name)+"&iconimage="+urllib.parse.quote_plus(iconimage)
    u=sys.argv[0]+"?url="+urllib.parse.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.parse.quote_plus(name)+"&iconimage="+urllib.parse.quote_plus(iconimage)+"&poster="+urllib.parse.quote_plus(thePoster)
    ok=True
    liz = xbmcgui.ListItem(name)
    liz.setArt({'thumb': iconimage, 'icon': "DefaultVideo.png", 'fanart': fanart})
    liz.setArt({'poster': thePoster})
    liz.setInfo( type = "Video", infoLabels = { "Title": name } )
    liz.setProperty('IsPlayable', 'true')
    ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
    return ok
  except: #Python2
    #u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)
    u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)+"&poster="+urllib.quote_plus(thePoster)
    liz=xbmcgui.ListItem(name)
    #liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
    liz.setArt({'thumb': iconimage, 'icon': "DefaultVideo.png", 'fanart': fanart})
    liz.setArt({'poster': thePoster})
    liz.setInfo( type="Video", infoLabels={"Title": name})		
    liz.setProperty('fanart_image', fanart)
    liz.setProperty('IsPlayable', 'true')
    ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)		
    return ok

#==============================================================================================================================

def cleanTEXT(theText):

    TEXT = (theText.
    		replace('\\xe2\\x80\\x99', "'").
            replace('\\xe2\\x80\\x90', '-').
            replace('\\xe2\\x80\\x91', '-').
            replace('\\xe2\\x80\\x92', '-').
            replace('\\xe2\\x80\\x93', '-').
            replace('\\xe2\\x80\\x94', '-').
            replace('\\xe2\\x80\\x94', '-').
            replace('\\xe2\\x80\\x98', "'").
            replace('\\xe2\\x80\\x9b', "'").
            replace('\\xe2\\x80\\x9c', '"').
            replace('\\xe2\\x80\\x9c', '"').
            replace('\\xe2\\x80\\x9d', '"').
            replace('\\xe2\\x80\\x9e', '"').
            replace('\\xe2\\x80\\x9f', '"').
            replace('\\xe2\\x80\\xa6', '...').
            replace('\\xe2\\x80\\xb2', "'").
            replace('\\xe2\\x80\\xb3', "'").
            replace('\\xe2\\x80\\xb4', "'").
            replace('\\xe2\\x80\\xb5', "'").
            replace('\\xe2\\x80\\xb6', "'").
            replace('\\xe2\\x80\\xb7', "'").
            replace('\\xe2\\x81\\xba', "+").
            replace('\\xe2\\x81\\xbb', "-").
            replace('\\xe2\\x81\\xbc', "=").
            replace('\\xe2\\x81\\xbd', "(").
            replace('\\xe2\\x81\\xbe', ")").
            replace('\\xc3\\xa1', 'a').
            replace('\\xc3\\xa9', 'e').
            replace('\\xc3\\xad','i').
            replace('\\xc3\\xb1','n').
            replace('\\xc2\\xba','o').
            replace('\\xc3\\xb3','o').
            replace('\\xc3\\xbc','u').
            replace('\\xc3\\xba','u').
            replace('\\xc3\\x81','A').
            replace('\\xc3\\x89','E').
            replace('\\xc3\\x93','O').
            replace('\\xc3\\x8a','E').
            replace('\\xd0\\xa0', 'P').
            replace('\\xd0\\x92', 'B').
            replace('\\xd0\\x90', 'A').
            replace("\\xc2\\xa0", " ").			
            replace('\\xc5\\xab','').			
            replace("\\'","'").
    		replace('\\\\xe2\\\\x80\\\\x99', "'").
            replace('\\\\xe2\\\\x80\\\\x90', '-').
            replace('\\\\xe2\\\\x80\\\\x91', '-').
            replace('\\\\xe2\\\\x80\\\\x92', '-').
            replace('\\\\xe2\\\\x80\\\\x93', '-').
            replace('\\\\xe2\\\\x80\\\\x94', '-').
            replace('\\\\xe2\\\\x80\\\\x94', '-').
            replace('\\\\xe2\\\\x80\\\\x98', "'").
            replace('\\\\xe2\\\\x80\\\\x9b', "'").
            replace('\\\\xe2\\\\x80\\\\x9c', '"').
            replace('\\\\xe2\\\\x80\\\\x9c', '"').
            replace('\\\\xe2\\\\x80\\\\x9d', '"').
            replace('\\\\xe2\\\\x80\\\\x9e', '"').
            replace('\\\\xe2\\\\x80\\\\x9f', '"').
            replace('\\\\xe2\\\\x80\\\\xa6', '...').
            replace('\\\\xe2\\\\x80\\\\xb2', "'").
            replace('\\\\xe2\\\\x80\\\\xb3', "'").
            replace('\\\\xe2\\\\x80\\\\xb4', "'").
            replace('\\\\xe2\\\\x80\\\\xb5', "'").
            replace('\\\\xe2\\\\x80\\\\xb6', "'").
            replace('\\\\xe2\\\\x80\\\\xb7', "'").
            replace('\\\\xe2\\\\x81\\\\xba', "+").
            replace('\\\\xe2\\\\x81\\\\xbb', "-").
            replace('\\\\xe2\\\\x81\\\\xbc', "=").
            replace('\\\\xe2\\\\x81\\\\xbd', "(").
            replace('\\\\xe2\\\\x81\\\\xbe', ")").
            replace('\\\\xc3\\\\xa1', 'a').
            replace('\\\\xc3\\\\xa9', 'e').
            replace('\\\\xc3\\\\xad','i').
            replace('\\\\xc3\\\\xb1','n').
            replace('\\\\xc2\\\\xba','o').
            replace('\\\\xc3\\\\xb3','o').
            replace('\\\\xc3\\\\xbc','u').
            replace('\\\\xc3\\\\xba','u').
            replace('\\\\xc3\\\\x81','A').
            replace('\\\\xc3\\\\x89','E').
            replace('\\\\xc3\\\\x93','O').
            replace('\\\\xc3\\\\x8a','E').
            replace('\\\\xd0\\\\xa0', 'P').
            replace('\\\\xd0\\\\x92', 'B').
            replace('\\\\xd0\\\\x90', 'A').
            replace("\\\\xc2\\\\xa0", " ").			
            replace('\\\\xc5\\\\xab','').			
            replace("\\\\'","'").
            replace('&#8212;', '—').
            replace('&#8216;', '\'').
            replace('&#8217;', '\'').
            replace('&#8211;', '-').
            replace('&#8220;', '"').
            replace('&#8221;', '"').
            replace('&#038;', '&').
            replace('&#60;', '<').
            replace('&#62;', '>').
            replace('&#34;', '"').
            replace('&#39;', "'").
            replace('&nbsp;', ' ').
            replace("&amp;", "&").
            replace('&hellip;', '').
            replace('&quot;', '"').
            replace('&apos;', "'")
                 )
    return TEXT

#==============================================================================================================================
	
def cleanString(theSTRING):

    parser = HTMLParser()
    input = theSTRING
    output = parser.unescape(input)
    finalOutput = filterSpecialChars(output)	

    #errorMsg="%s" % (finalOutput)
    #xbmcgui.Dialog().textviewer("finalOutput", errorMsg)

    return finalOutput

def filterSpecialChars(strInput):
    result = []
    for character in strInput:
        ordVal = ord(character)
        if ordVal < 0 or ordVal > 127:
            result.append('')
        else:
            result.append(character)
    return ''.join(result)

#==============================================================================================================================

def urlExists(url):

    request = Request(url)
    request.get_method = lambda: 'HEAD'

    try:
        urlopen(request)
        return True
    except HTTPError:
        return False

#==============================================================================================================================

def regex_get_all(text, start_with, end_with):
	r = re.findall("(?i)(" + start_with + "[\S\s]+?" + end_with + ")", text)
	return r

#==============================================================================================================================
